#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>

#define RELE PB5 // pin 13 na Arduino UNO
#define RX PD2  // soft RX
#define TX PD3  // soft TX



char get_char() {
    uint8_t i;
    char receivedChar = 0;

   
    while (PIND & (1 << RX));
    _delay_us(104 + 52); 

    for (i = 0; i < 8; i++) {
        if (PIND & (1 << RX))
            receivedChar |= (1 << i);
        _delay_us(104);
    }

  
    _delay_us(104);

    return receivedChar;
}

int main(void) {

    DDRB |= (1 << RELE); // Rele pin ako vstup
    DDRD |= (1 << TX);  // TX pin ako vstup
    DDRD &= ~(1 << RX); // RX pin ako vstup
    PORTD |= (1 << RX); // pull-up na RX

    

    while (1) {
        char c = get_char();
        
        if (c == '0') {
    PORTB &= ~(1 << RELE); // aktivuj rel - LOW
} else if (c == '1') {
    PORTB |= (1 << RELE); // deaktivuj rel - HIGH
}
            
        }
    }